#ifndef __ITERDE_H__
#define __ITERDE_H__

#define HOOK_TYPE_REPLACE   0
#define HOOK_TYPE_PREHOOK   1
#define HOOK_TYPE_POSTHOOK  2
#define HOOK_TYPE_POINTER   3
#define HOOK_TYPE_ARBITRARY 4

#define ADDR(x) (x)

#define EXPORT __declspec(dllexport)
#define XXX() std::cerr << ("WARNING: calling unfinished function at " __FILE__ ":%d\n", __LINE__); __asm int 3;

class Hooker {
	void makeMemoryWritable(void *address);
public:
	Hooker(unsigned char *originalAddress, unsigned char *newAddress, int type);
	~Hooker();
};

#define replace(address, handler) \
	Hooker __init_##handler ((unsigned char*)address, (unsigned char*)&handler, HOOK_TYPE_REPLACE);
#endif
